### Method

# FwupdPlugin Device get_contents

since: 2.0.12

#### Declaration [src]

    gchar*
    fu_device_get_contents (
      FuDevice* self,
      const gchar* filename,
      gsize count,
      FuProgress* progress,
      GError** error
    )

#### Description [src]

Reads a blob of ASCII text from the file, emulating if required.

Available since: 2.0.12

#### Parameters

`filename`

  Type: `const gchar*`

  Full path to a file.

  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`count`

  Type: `gsize`

  Maximum number of bytes to read.

`progress`

  Type: `FuProgress`

  Optional `FuProgress`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gchar*`

A `GBytes`, or `NULL` on error.

The caller of the method takes ownership of the returned data, and is responsible for freeing it.
The value is a NUL terminated UTF-8 string.